﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
namespace DHTMLX.Export.PDF.Scheduler
{
    public class SchedulerMonth
    {
        private string monthName;
        private string[,] rows;

        public void Parse(XmlNode parent) {
		    this.monthName = parent.Attributes["label"].Value;
            List<XmlNode> parsRows = XMLParser.GetElementsByTagName(parent, "row");
            List<XmlNode> cols = XMLParser.GetElementsByTagName(parent, "column");
           
		   	if ((parsRows.Count != 0)&&(cols.Count != 0)) {
			    this.rows= new string[parsRows.Count + 1,7];
			    for (int i = 0; i < cols.Count; i++) {
				    this.rows[0,i] = cols[i].FirstChild.Value;
			    }
                for (int i = 1; i <= parsRows.Count; i++)
                {
                    var values = parsRows[i - 1].FirstChild.Value.Split(new string[1]{"|"}, StringSplitOptions.None);
                    for (var j = 0; j < values.Length; j++)
                    {
                        this.rows[i, j] = values[j];
                    }
			    }
		    }
	    }

        public string GetLabel()
        {
            return this.monthName;
        }

        public string[,] GetRows()
        {
            return this.rows;
        }

        public string[,] GetOnlyDays()
        {
            var days = new string[this.rows.GetLength(0)-1, 7];


            for (int i = 1; i < this.rows.GetLength(0); i++)
            {
                for (var j = 0; j < 7; j++)
                {
                    days[i - 1,j] = this.rows[i,j];
                }
            }
            return days;
        }
    }
}
