﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
namespace DHTMLX.Export.PDF
{
    public class TreeTimelineCategory{
        public bool Expanded { get; set; }
        public int Level { get; set; }
        public bool IsExpandable { get; set; }
        public string Text { get; set; }
        public TreeTimelineCategory(string text, int level, bool allowchild, bool expanded)
        {
            this.Level = level;
            this.Expanded = expanded;
            this.IsExpandable = allowchild;
            this.Text = text;
        }
        public TreeTimelineCategory():this("", 0, false, false)
        {

        }
    }
    /*
    <div class=\"dhx_scell_level0\"><div class=\"dhx_scell_expand\">-</div><div class=\"dhx_scell_name\">Web Testing Dep.</div></div>
<div class=\"dhx_scell_level1\"><div class=\"dhx_scell_expand\"> </div><div class=\"dhx_scell_name\">Managers</div></div>
<div class=\"dhx_scell_level1\"><div class=\"dhx_scell_name\">Elizabeth Taylor</div></div>"
    */
   
    public class TreeTimelineParser
    {
        public static bool IsTreeRow(string item){
            var treeRowRegex = "^<div.*dhx_scell_level.*>.*(dhx_scell_expand|dhx_scell_name).*<\\/div>$";
            return(Regex.IsMatch(item.Trim(), treeRowRegex));
        }
        public TreeTimelineCategory Parse(string item)
        {
            var levelReg = "dhx_scell_level([0-9]+)";
            var isExpandable = "dhx_scell_expand";
            var state = "dhx_scell_expand.*?>(-| )<\\/div";
            var text = "dhx_scell_name.*?>(.+?)<\\/div";
            bool expandable = Regex.IsMatch(item, isExpandable);
            int level = 0; 
            int.TryParse(Regex.Match(item, levelReg).Groups[1].Value, out level);
            bool expanded = Regex.Match(item, state).Groups[1].Value == "-" ? true : false;
            string value = Regex.Match(item, text).Groups[1].Value;
            return new TreeTimelineCategory(value, level, expandable, expanded);


        }
     //   public 
    }
}
